Grouping in React ListView component

ListView supports wrapping nested elements into groups based on categories.

The category of each list item can be mapped using the groupBy field in the data table, which also supports single-level navigation.

In the sample below, cars are grouped based on their categories using the groupBy field.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
function App() {
    // define the array of Json
    let arts = [
        {
            'text': 'Audi A4',
            'id': '9bdb',
            'category': 'Audi'
        },
        {
            'text': 'Audi A5',
            'id': '4589',
            'category': 'Audi'
        },
        {
            'text': 'BMW 501',
            'id': 'f849',
            'category': 'BMW'
        },
        {
            'text': 'BMW 502',
            'id': '7aff',
            'category': 'BMW'
        }
    ];
    let fields = { groupBy: 'category', tooltip: 'text' };
    return (
        // specifies the tag to render the ListView component
        <ListViewComponent id='list' dataSource={arts} fields={fields}></ListViewComponent>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';

function App() {
  // define the array of Json
  let arts: { [key: string]: string }[] = [
    {
      'text': 'Audi A4',
      'id': '9bdb',
      'category': 'Audi'
    },
    {
      'text': 'Audi A5',
      'id': '4589',
      'category': 'Audi'
    },
    {
      'text': 'BMW 501',
      'id': 'f849',
      'category': 'BMW'
    },
    {
      'text': 'BMW 502',
      'id': '7aff',
      'category': 'BMW'
    }
  ];

  let fields = { groupBy: 'category', tooltip: 'text' };
  return (
    // specifies the tag to render the ListView component
    <ListViewComponent id='list' dataSource={arts} fields={fields} ></ListViewComponent>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#list {
  display: block;
  max-width: 400px;
  margin: auto;
  border: 1px solid #dddddd;
  border-radius: 3px;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Customization

The grouping header can be customized using the groupTemplate property for both inline and fixed group headers. The complete customization description and explanation, along with an example, are given in the following link.

Group Template

Grouping in Vue ListView component

The ListView supports grouping nested elements based on their category. The cars are grouped based on their category by using the groupBy field in the data table, that also supports single-level navigation.

In the following sample, The cars are grouped based on its category by using the groupBy field.

<template>
  <div class="control-section">
    <div id='group-list'>
      <!-- Group ListView element -->
      <ejs-listview id='sample-list-group' :dataSource='cars' :fields='fields'></ejs-listview>
    </div>
  </div>
</template>

<script setup>

import { ListViewComponent as EjsListview } from "@syncfusion/ej2-vue-lists";

const cars = [
  {
    'text': 'Audi A4',
    'id': '9bdb',
    'category': 'Audi'
  },
  {
    'text': 'Audi A5',
    'id': '4589',
    'category': 'Audi'
  },
  {
    'text': 'BMW 501',
    'id': 'f849',
    'category': 'BMW'
  },
  {
    'text': 'BMW 502',
    'id': '7aff',
    'category': 'BMW'
  }
];
const fields = { groupBy: 'category', tooltip: 'text' };

</script>
<style>
#sample-list-group {
  border: 1px solid #dddddd;
  border-radius: 3px;
  margin: auto;
}

#group-list {
  width: 50%;
  padding: 10px;
  margin: auto;
}
</style>
<template>
  <div class="control-section">
    <div id='group-list'>
      <!-- Group ListView element -->
      <ejs-listview id='sample-list-group' :dataSource='cars' :fields='fields'></ejs-listview>
    </div>
  </div>
</template>

<script>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";

export default {
  name: "App",
  components: {
    "ejs-listview": ListViewComponent
  },

  data: function () {
    return {
      cars: [
        {
          'text': 'Audi A4',
          'id': '9bdb',
          'category': 'Audi'
        },
        {
          'text': 'Audi A5',
          'id': '4589',
          'category': 'Audi'
        },
        {
          'text': 'BMW 501',
          'id': 'f849',
          'category': 'BMW'
        },
        {
          'text': 'BMW 502',
          'id': '7aff',
          'category': 'BMW'
        }
      ],
      fields: { groupBy: 'category', tooltip: 'text' }
    };
  }
}
</script>
<style>
#sample-list-group {
  border: 1px solid #dddddd;
  border-radius: 3px;
  margin: auto;
}

#group-list {
  width: 50%;
  padding: 10px;
  margin: auto;
}
</style>

Customization

The grouping header can be customized by using the groupTemplate property for both inline and fixed group header. The complete customization description and explanation with an example is given in the following link.

Group Template.

Grouping in Angular ListView component

25 Sep 20263 minutes to read

The Angular ListView component supports organizing items into groups based on categories. Each list item’s category can be mapped using the groupBy field in the data source, enabling single-level navigation within grouped content.

In the sample below, cars are grouped based on their category using the groupBy field.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ListViewModule } from '@syncfusion/ej2-angular-lists'
import { Component } from '@angular/core';

@Component({
    imports: [
        ListViewModule
    ],
    standalone: true,
    selector: 'my-app',
    template: `<ejs-listview id='sample-list' [dataSource]='data' [fields]='fields' ></ejs-listview>`
})

export class AppComponent {
    public data: Object = [
        {
            'text': 'Audi A4',
            'id': '9bdb',
            'category': 'Audi'
        },
        {
            'text': 'Audi A5',
            'id': '4589',
            'category': 'Audi'
        },
        {
            'text': 'BMW 501',
            'id': 'f849',
            'category': 'BMW'
        },
        {
            'text': 'BMW 502',
            'id': '7aff',
            'category': 'BMW'
        }
    ];
    public fields: Object = { groupBy: 'category', tooltip: 'text' };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customization

The grouping header can be customized using the groupTemplate property. This property allows you to define custom templates for group headers in both inline and fixed header scenarios. The groupTemplate accepts string or function templates to render custom content, enabling you to add icons, styling, or additional information to group headers based on your application requirements.